﻿
Imports DirectShowLib

Public Class Form_VideoInControls

    Private Sub Form_VideoInControls_Activated(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Activated
        UpdateAllValues()
    End Sub

    Private Sub SetDefaultFocus()
        ToolStrip1.Focus()
    End Sub

    Private Sub MyButton_Close_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Close.ClickButtonArea
        Me.Hide()
    End Sub

    Private Sub MyButton_DefaultAll_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_DefaultAll.ClickButtonArea
        DefaultAllParams()
    End Sub

    Private Sub Tool_SourcePanel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_SourcePanel.Click
        AsyncExecutionTimer_Start("Source Panel")
    End Sub
    Private Sub Tool_FormatPanel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Tool_FormatPanel.Click
        AsyncExecutionTimer_Start("Format Panel")
    End Sub


    ' ----------------------------------------------------------------------------------------------
    '  Async Execution Timer  ( used to execute out of event handlers )
    ' ----------------------------------------------------------------------------------------------
    Private WithEvents AsyncExecutionTimer As System.Windows.Forms.Timer = New System.Windows.Forms.Timer
    Private Sub AsyncExecutionTimer_Start(ByVal command As String)
        AsyncExecutionTimer.Tag = command
        AsyncExecutionTimer.Interval = 100
        AsyncExecutionTimer.Start()
    End Sub
    Private Sub Timer_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles AsyncExecutionTimer.Tick
        AsyncExecutionTimer.Stop()
        Dim cmd As String = AsyncExecutionTimer.Tag.ToString
        Select Case cmd
            Case "Source Panel"
                ShowCaptureFilterDialog(Me.Handle)
                Capture_GetVideoParams()
                ShowVideoParams()
            Case "Format Panel"
                ShowCapturePinDialog(Me.Handle)
                Capture_GetVideoFormatParams()
                ShowVideoFormatParams()
        End Select
    End Sub


    Friend Sub UpdateAllValues()
        Capture_GetVideoParams()
        ShowVideoParams()
        Capture_GetVideoFormatParams()
        ShowVideoFormatParams()
    End Sub


    ' ==============================================================================================================
    '   COMBO BOX - VideoFormat
    ' ==============================================================================================================
    Private Sub ComboBox_VideoFormat_InitWithCurrentValue()
        Combo_Init(ComboBox_VideoFormat, VideoFormatParams.VideoFormat)
    End Sub
    Private Sub ComboBox_VideoFormat_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoFormat.DropDownClosed
        SetDefaultFocus()
    End Sub
    Private Sub ComboBox_VideoFormat_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox_VideoFormat.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        VideoFormatParams.VideoFormat = Combo_GetValue(ComboBox_VideoFormat)
        '
        Capture_SetVideoFormatParams()
        Capture_GetVideoFormatParams()
        ShowVideoFormatParams()
        SetDefaultFocus()
        Save_INI()
    End Sub
    Private Sub ComboBox_VideoFormat_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoFormat.DropDown
        With ComboBox_VideoFormat
            .Items.Clear()
            .Items.AddRange(Capture_GetValidVideoFormats())
            Combo_SetIndex_FromString(ComboBox_VideoFormat, VideoFormatParams.VideoFormat)
        End With
    End Sub

    ' ==============================================================================================================
    '   COMBO BOX - VideoSize
    ' ==============================================================================================================
    Private Sub ComboBox_VideoSize_InitWithCurrentValue()
        Combo_Init(ComboBox_VideoSize, VideoFormatParams.VideoSize)
    End Sub
    Private Sub ComboBox_VideoSize_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoSize.DropDownClosed
        SetDefaultFocus()
    End Sub
    Private Sub ComboBox_VideoSize_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox_VideoSize.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        VideoFormatParams.VideoSize = Combo_GetValue(ComboBox_VideoSize)
        '
        Capture_SetVideoFormatParams()
        Capture_GetVideoFormatParams()
        ShowVideoFormatParams()
        SetDefaultFocus()
        Save_INI()
    End Sub
    Private Sub ComboBox_VideoSize_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoSize.DropDown
        With ComboBox_VideoSize
            .Items.Clear()
            .Items.AddRange(Capture_GetValidVideoSizes())
            Combo_SetIndex_FromString(ComboBox_VideoSize, VideoFormatParams.VideoSize)
        End With
    End Sub


    ' ==============================================================================================================
    '   COMBO BOX - VideoFPS
    ' ==============================================================================================================
    Private Sub ComboBox_VideoFPS_InitWithCurrentValue()
        Combo_Init(ComboBox_VideoFPS, VideoFormatParams.VideoFPS)
    End Sub
    Private Sub ComboBox_VideoFPS_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoFPS.DropDownClosed
        SetDefaultFocus()
    End Sub
    Private Sub ComboBox_VideoFPS_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox_VideoFPS.SelectedIndexChanged
        If Not EventsAreEnabled Then Exit Sub
        VideoFormatParams.VideoFPS = Combo_GetValue(ComboBox_VideoFPS)
        '
        Capture_SetVideoFormatParams()
        Capture_GetVideoFormatParams()
        ShowVideoFormatParams()
        SetDefaultFocus()
        Save_INI()
    End Sub
    Private Sub ComboBox_VideoInputDevice_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles ComboBox_VideoFPS.DropDown
        With ComboBox_VideoFPS
            .Items.Clear()
            .Items.AddRange(Capture_GetValidVideoFPS())
            Combo_SetIndex_FromString(ComboBox_VideoFPS, VideoFormatParams.VideoFPS)
        End With
    End Sub



    Private Sub ShowVideoParams()
        InitTrackBarAndLabel(MyButton_Exposure, CheckBox_Exposure, TrackBar_Exposure, Label_Exposition, VideoInputParams.Exposure)
        InitTrackBarAndLabel(MyButton_Brightness, CheckBox_Brightness, TrackBar_Brightness, Label_Brightness, VideoInputParams.Brightness)
        InitTrackBarAndLabel(MyButton_Contrast, CheckBox_Contrast, TrackBar_Contrast, Label_Contrast, VideoInputParams.Contrast)
        InitTrackBarAndLabel(MyButton_Gamma, CheckBox_Gamma, TrackBar_Gamma, Label_Gamma, VideoInputParams.Gamma)
        InitTrackBarAndLabel(MyButton_Saturation, CheckBox_Saturation, TrackBar_Saturation, Label_Saturation, VideoInputParams.Saturation)
        InitTrackBarAndLabel(MyButton_WhiteBalance, CheckBox_WhiteBalance, TrackBar_WhiteBalance, Label_WhiteBalance, VideoInputParams.WhiteBalance)
        InitTrackBarAndLabel(MyButton_Hue, CheckBox_Hue, TrackBar_Hue, Label_Hue, VideoInputParams.Hue)
        InitTrackBarAndLabel(MyButton_Sharpness, CheckBox_Sharpness, TrackBar_Sharpness, Label_Sharpness, VideoInputParams.Sharpness)
        InitTrackBarAndLabel(MyButton_Zoom, CheckBox_Zoom, TrackBar_Zoom, Label_Zoom, VideoInputParams.Zoom)
        InitTrackBarAndLabel(MyButton_Pan, CheckBox_Pan, TrackBar_Pan, Label_Pan, VideoInputParams.Pan)
        InitTrackBarAndLabel(MyButton_Tilt, CheckBox_Tilt, TrackBar_Tilt, Label_Tilt, VideoInputParams.Tilt)
    End Sub

    Private Sub ShowVideoFormatParams()
        If VideoCaptureDevice_Is_VFW() Then
            ComboBox_VideoFormat.Enabled = False
            ComboBox_VideoSize.Enabled = False
            ComboBox_VideoFPS.Enabled = False
            Combo_Init(ComboBox_VideoFormat, "")
            Combo_Init(ComboBox_VideoSize, "")
            Combo_Init(ComboBox_VideoFPS, "")
            MyButton_DefaultAll.Visible = False
        Else
            ComboBox_VideoFormat.Enabled = True
            ComboBox_VideoSize.Enabled = True
            ComboBox_VideoFPS.Enabled = True
            ComboBox_VideoFormat_InitWithCurrentValue()
            ComboBox_VideoSize_InitWithCurrentValue()
            ComboBox_VideoFPS_InitWithCurrentValue()
            MyButton_DefaultAll.Visible = True
        End If
    End Sub


    Private Sub InitTrackBarAndLabel(ByVal button As CustomControlsLib.MyButton, _
                                     ByVal chkbox As CheckBox, _
                                     ByVal tbar As TrackBar, _
                                     ByVal lbl As Label, _
                                     ByVal param As Capture_VideoInputParam)


        If param._AutoValid Then
            chkbox.Visible = True
            chkbox.Checked = param._AutoChecked
            If param._AutoChecked Then
                tbar.Enabled = False
                lbl.Enabled = False
            Else
                tbar.Enabled = True
                lbl.Enabled = True
            End If
        Else
            chkbox.Visible = False
            tbar.Enabled = True
            lbl.Enabled = True
        End If

        If param._Max <> param._Min Then
            button.Visible = True
            tbar.Minimum = param._Min
            tbar.Maximum = param._Max
            tbar.SmallChange = param._Step
            tbar.TickFrequency = CInt(Math.Abs(param._Max - param._Min) / 10)
            If param._Value > param._Max Then param._Value = param._Max
            If param._Value < param._Min Then param._Value = param._Min
            tbar.Value = param._Value
            lbl.Text = param._Value.ToString
        Else
            button.Visible = False
            chkbox.Visible = False
            tbar.Enabled = False
            lbl.Enabled = False
            lbl.Text = ""
        End If
    End Sub


    Private Sub Auto_CheckBoxes_CheckedChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBox_Exposure.CheckedChanged, _
                                                                                                            CheckBox_Brightness.CheckedChanged, _
                                                                                                            CheckBox_Contrast.CheckedChanged, _
                                                                                                            CheckBox_Gamma.CheckedChanged, _
                                                                                                            CheckBox_Saturation.CheckedChanged, _
                                                                                                            CheckBox_WhiteBalance.CheckedChanged, _
                                                                                                            CheckBox_Hue.CheckedChanged, _
                                                                                                            CheckBox_Sharpness.CheckedChanged, _
                                                                                                            CheckBox_Zoom.CheckedChanged, _
                                                                                                            CheckBox_Pan.CheckedChanged, _
                                                                                                            CheckBox_Tilt.CheckedChanged
        SetAllAuto()
        ShowVideoParams()
    End Sub

    Private Sub TrackBars_MouseLeave(ByVal sender As Object, ByVal e As System.EventArgs) Handles TrackBar_Exposure.MouseLeave, _
                                                                                                     TrackBar_Brightness.MouseLeave, _
                                                                                                     TrackBar_Contrast.MouseLeave, _
                                                                                                     TrackBar_Gamma.MouseLeave, _
                                                                                                     TrackBar_Saturation.MouseLeave, _
                                                                                                     TrackBar_WhiteBalance.MouseLeave, _
                                                                                                     TrackBar_Hue.MouseLeave, _
                                                                                                     TrackBar_Sharpness.MouseLeave, _
                                                                                                     TrackBar_Zoom.MouseLeave, _
                                                                                                     TrackBar_Pan.MouseLeave, _
                                                                                                     TrackBar_Tilt.MouseLeave
        SetDefaultFocus()
    End Sub


    Private Sub TrackBars_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_Exposure.Scroll, _
                                                                                                     TrackBar_Brightness.Scroll, _
                                                                                                     TrackBar_Contrast.Scroll, _
                                                                                                     TrackBar_Gamma.Scroll, _
                                                                                                     TrackBar_Saturation.Scroll, _
                                                                                                     TrackBar_WhiteBalance.Scroll, _
                                                                                                     TrackBar_Hue.Scroll, _
                                                                                                     TrackBar_Sharpness.Scroll, _
                                                                                                     TrackBar_Zoom.Scroll, _
                                                                                                     TrackBar_Pan.Scroll, _
                                                                                                     TrackBar_Tilt.Scroll
        SetAllParams()
        ShowVideoParams()
    End Sub

    Private Sub SetAllAuto()
        VideoInputParams.Exposure._AutoChecked = CheckBox_Exposure.Checked
        VideoInputParams.Brightness._AutoChecked = CheckBox_Brightness.Checked
        VideoInputParams.Contrast._AutoChecked = CheckBox_Contrast.Checked
        VideoInputParams.Gamma._AutoChecked = CheckBox_Gamma.Checked
        VideoInputParams.Saturation._AutoChecked = CheckBox_Saturation.Checked
        VideoInputParams.WhiteBalance._AutoChecked = CheckBox_WhiteBalance.Checked
        VideoInputParams.Hue._AutoChecked = CheckBox_Hue.Checked
        VideoInputParams.Sharpness._AutoChecked = CheckBox_Sharpness.Checked
        VideoInputParams.Zoom._AutoChecked = CheckBox_Zoom.Checked
        VideoInputParams.Pan._AutoChecked = CheckBox_Pan.Checked
        VideoInputParams.Tilt._AutoChecked = CheckBox_Tilt.Checked
        Capture_SetVideoParams()
    End Sub

    Private Sub SetAllParams()
        VideoInputParams.Exposure._Value = TrackBar_Exposure.Value
        VideoInputParams.Brightness._Value = TrackBar_Brightness.Value
        VideoInputParams.Contrast._Value = TrackBar_Contrast.Value
        VideoInputParams.Gamma._Value = TrackBar_Gamma.Value
        VideoInputParams.Saturation._Value = TrackBar_Saturation.Value
        VideoInputParams.WhiteBalance._Value = TrackBar_WhiteBalance.Value
        VideoInputParams.Hue._Value = TrackBar_Hue.Value
        VideoInputParams.Sharpness._Value = TrackBar_Sharpness.Value
        VideoInputParams.Zoom._Value = TrackBar_Zoom.Value
        VideoInputParams.Pan._Value = TrackBar_Pan.Value
        VideoInputParams.Tilt._Value = TrackBar_Tilt.Value
        Capture_SetVideoParams()
    End Sub


    Private Sub DefaultAllParams()
        VideoInputParams.Exposure._Value = VideoInputParams.Exposure._Default
        VideoInputParams.Brightness._Value = VideoInputParams.Brightness._Default
        VideoInputParams.Contrast._Value = VideoInputParams.Contrast._Default
        VideoInputParams.Gamma._Value = VideoInputParams.Gamma._Default
        VideoInputParams.Saturation._Value = VideoInputParams.Saturation._Default
        VideoInputParams.WhiteBalance._Value = VideoInputParams.WhiteBalance._Default
        VideoInputParams.Hue._Value = VideoInputParams.Hue._Default
        VideoInputParams.Sharpness._Value = VideoInputParams.Sharpness._Default
        VideoInputParams.Zoom._Value = VideoInputParams.Zoom._Default
        VideoInputParams.Pan._Value = VideoInputParams.Pan._Default
        VideoInputParams.Tilt._Value = VideoInputParams.Tilt._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub



    Private Sub MyButton_Exposure_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Exposure.ClickButtonArea
        VideoInputParams.Exposure._Value = VideoInputParams.Exposure._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_Brightness_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Brightness.ClickButtonArea
        VideoInputParams.Brightness._Value = VideoInputParams.Brightness._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_Contrast_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Contrast.ClickButtonArea
        VideoInputParams.Contrast._Value = VideoInputParams.Contrast._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_Gamma_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Gamma.ClickButtonArea
        VideoInputParams.Gamma._Value = VideoInputParams.Gamma._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_Saturation_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Saturation.ClickButtonArea
        VideoInputParams.Saturation._Value = VideoInputParams.Saturation._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_WhiteBalance_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_WhiteBalance.ClickButtonArea
        VideoInputParams.WhiteBalance._Value = VideoInputParams.WhiteBalance._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_Hue_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Hue.ClickButtonArea
        VideoInputParams.Hue._Value = VideoInputParams.Hue._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_Sharpness_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Sharpness.ClickButtonArea
        VideoInputParams.Sharpness._Value = VideoInputParams.Sharpness._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_Zoom_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Zoom.ClickButtonArea
        VideoInputParams.Zoom._Value = VideoInputParams.Zoom._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_Pan_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Pan.ClickButtonArea
        VideoInputParams.Pan._Value = VideoInputParams.Pan._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub
    Private Sub MyButton_Tilt_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles MyButton_Tilt.ClickButtonArea
        VideoInputParams.Tilt._Value = VideoInputParams.Tilt._Default
        Capture_SetVideoParams()
        ShowVideoParams()
    End Sub



    Friend Sub Capture_GetVideoParams()
        'Dim t As PrecisionTimer = New PrecisionTimer

        ' --------------------------------------------------------------------------------------------------
        ' existing params tests
        ' --------------------------------------------------------------------------------------------------
        'Dim p As Capture_VideoInputParam
        'p = Capture_GetCameraControlParam(CameraControlProperty.Focus)

        'p = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.BacklightCompensation)
        'p = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.ColorEnable)
        'p = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.Gain)
        'p = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.Hue)
        ' --------------------------------------------------------------------------------------------------

        '
        VideoInputParams.Exposure = Capture_GetCameraControlParam(CameraControlProperty.Exposure)
        VideoInputParams.Brightness = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.Brightness)
        VideoInputParams.Contrast = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.Contrast)
        VideoInputParams.Gamma = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.Gamma)
        VideoInputParams.Saturation = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.Saturation)
        VideoInputParams.WhiteBalance = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.WhiteBalance)
        VideoInputParams.Hue = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.Hue)
        VideoInputParams.Sharpness = Capture_GetVideoProcAmpParam(VideoProcAmpProperty.Sharpness)
        VideoInputParams.Zoom = Capture_GetCameraControlParam(CameraControlProperty.Zoom)
        VideoInputParams.Pan = Capture_GetCameraControlParam(CameraControlProperty.Pan)
        VideoInputParams.Tilt = Capture_GetCameraControlParam(CameraControlProperty.Tilt)

        ' ------------------------------------------------------ todo remove and test automatically
        VideoInputParams.Exposure._AutoValid = True
        VideoInputParams.WhiteBalance._AutoValid = True
        '
        't.DebugPrintMicrosec()
        'Debug.Print(VideoInputParams.Brightness.Value.ToString)
    End Sub

    Friend Sub Capture_SetVideoParams()
        Capture_SetCameraControlParam(CameraControlProperty.Exposure, VideoInputParams.Exposure)
        '
        Capture_SetVideoProcAmpParam(VideoProcAmpProperty.Brightness, VideoInputParams.Brightness)
        Capture_SetVideoProcAmpParam(VideoProcAmpProperty.Contrast, VideoInputParams.Contrast)
        Capture_SetVideoProcAmpParam(VideoProcAmpProperty.Gamma, VideoInputParams.Gamma)
        Capture_SetVideoProcAmpParam(VideoProcAmpProperty.Hue, VideoInputParams.Hue)
        Capture_SetVideoProcAmpParam(VideoProcAmpProperty.Saturation, VideoInputParams.Saturation)
        Capture_SetVideoProcAmpParam(VideoProcAmpProperty.Sharpness, VideoInputParams.Sharpness)
        Capture_SetVideoProcAmpParam(VideoProcAmpProperty.WhiteBalance, VideoInputParams.WhiteBalance)
        '
        Capture_SetCameraControlParam(CameraControlProperty.Zoom, VideoInputParams.Zoom)
        Capture_SetCameraControlParam(CameraControlProperty.Pan, VideoInputParams.Pan)
        Capture_SetCameraControlParam(CameraControlProperty.Tilt, VideoInputParams.Tilt)

        Capture_SetVideoProcAmpParam(VideoProcAmpProperty.Hue, VideoInputParams.Hue)
    End Sub


End Class